###############################################################################
# gpd-0.2.0 - 15 January 2001
#
# General Purpose Daemon Library
#
# Msys - MCS Systems Administration Toolkit
#
# Copyright (C) 2000-2001  JP Navarro, navarro@mcs.anl.gov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# $Id: gpdLib.pl,v 1.1 2001/01/15 20:36:04 navarro Exp $
#
###############################################################################

###############################################################################
# Communications routines
###############################################################################
sub nonblock {
   my $socket = shift;

   unless (my $flags = fcntl($socket, F_GETFL, 0)) {
      $LOG->Fatal("Can't get socket flags: $!\n");
	  exit(1);
   }
   unless (fcntl($socket, F_SETFL, $flags | O_NONBLOCK)) {
      $LOG->Fatal("Can't set socket nonblocking flag: $!\n");
	  exit(1);
   }
}

sub cloexec {
   my $socket = shift;

   unless (my $flags = fcntl($socket, F_GETFD, 0)) {
      $LOG->Fatal("Can't get socket flags: $!\n");
	  exit(1);
   }
#  fcntl($socket, F_SETFD, $flags && !FD_CLOEXEC)
   unless (fcntl($socket, F_SETFD, 0)) {
      $LOG->Fatal("Can't set socket nonblocking flag: $!\n");
	  exit(1);
   }
}
###############################################################################
# Miscelaneous routines
###############################################################################
sub get_my_prog {
    my ($prog) = (shift);
    while ($prog =~ m#/#) { $prog = "$'"; }
    return($prog);
}

sub get_my_host {
    my ($mode) = (shift, shift);
    my $host = hostname();
    chomp $host;
    if ($mode eq 'short') {
        while ($host =~ m#\.#) { $host = "$`"; }
    }
    return($host);
}

sub timestamp {
   my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime();
   $mon++;
   if ($mon  < 10) { $mon  = '0'.$mon;  }
   if ($mday < 10) { $mday = '0'.$mday; }
   if ($hour < 10) { $hour = '0'.$hour; }
   if ($min  < 10) { $min  = '0'.$min;  }
   if ($sec  < 10) { $sec  = '0'.$sec;  }
   return("$year.$mon.$mday.$hour.$min.$sec");
}

sub timeprint {
   my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime();
   my @MONTHS = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
   $year += 1900;
   my $month = $mon + 1;
   if ($month < 10) { $mon  = '0'.$mon;  }
   if ($mday  < 10) { $mday = '0'.$mday; }
   if ($hour  < 10) { $hour = '0'.$hour; }
   if ($min   < 10) { $min  = '0'.$min;  }
   if ($sec   < 10) { $sec  = '0'.$sec;  }
   my $montxt = $MONTHS[$mon];
   return("$montxt $mday $hour:$min:$sec");
}

1;
